<!--#include file="../../owFunctions/I_GeneralFunctions.asp"-->
<%
	'************************************************************************************
	'*																					*
	'*	MODIFICATION TO THIS SCRIPT OR ANY FILES INCLUDED WITH 							*
	'*		ONEWORLDSTOREFRONT IS DONE AT YOUR OWN RISK!								*
	'*	Product  : OneWorldStoreFront													*

	'*	Copyright:	Copyright (C) 2004 OneWorldStoreFront.Com							*
	'*				Registration Number: 1024507										*
	'*				http://strategis.ic.gc.ca/											*
	'*																					*
	'************************************************************************************

	Call ActionSubroutine()
	
	'************************************************************************************
	'*																					*
	'*																					*
	'*																					*
	'************************************************************************************
	Sub ActionSubroutine()

		sLongIDOrder		= CONVERSION_SQLEncode2(Request("idOrder"),20)
		sCardType			= CONVERSION_SQLEncode2(Request("cardType"),4)
		sCardNumber			= CONVERSION_SQLEncode2(Request("cardNumber"),20)
		sExpirationMonth	= CONVERSION_SQLEncode2(Request("expMonth"),2)
		sExpirationYear		= CONVERSION_SQLEncode2(Request("expYear"),4)
		sExpiration			= sExpirationMonth & "/" & sExpirationYear 
		sSeqCode			= CONVERSION_SQLEncode2(Request("seqCode"),4)
		sNameOnCard			= CONVERSION_SQLEncode2(Request("nameOnCard"),50)
		sStatementAddress	= CONVERSION_SQLEncode2(Request("statementAddress"),300)

		If ( sOWOrderPrefix <> "" ) Then
			sIDOrder = Mid(sLongIDOrder, Len(sOWOrderPrefix) + 1)
		Else
			sIDOrder = sLongIDOrder
		End If

		sComments = Replace(Replace(LANG_DT( "OFFLINEPMT_COMMENTS", "Statement address receipt: 1: Name on card: 2:" ), "1:", sStatementAddress), "2:", sNameOnCard)
		
		' validates missing fields
		if trim(sIDOrder)="" then
			Response.Write LANG_DT( "OFFLINEPMT_IDORDERMISSING", "Error in form, hidden fields missing." )
		Else
			' validates expiration
			if DateDiff("d", Month(Now)&"/"&Year(now), sExpirationMonth&"/"&sExpirationYear)<0 then
				Call owMessage(LANG_DT( "OFFLINEPMT_EXPIREDCC", "It appears as though you have entered an expired credit cart. Please go back and double check your payment information." ), C_ERROR)
			Else
				if not ValidateCreditCard(sCardNumber, sCardType) then
					Call owMessage(LANG_DT( "OFFLINEPMT_INVALIDCC", "It appears as though you have entered an invalid credit cart number. Please go back and double check your payment information." ), C_ERROR)
				Else
					' encrypt CC data
					sEncryptedCard=EnCrypt(sCardNumber, strRc4Key)
					
					' save credit card info
					sSQLText = "INSERT INTO OrdersCreditCards (idOrder, cardType, cardNumber, expiration, seqcode, comments) VALUES (" &sIDOrder& ",'" &sCardType& "','" &sEncryptedCard& "','" &sExpiration& "','" &sSeqCode& "','" &sComments& "')"
					call DB_updateDatabase(sSQLText)
					
					' send encrypted email
					sEmailBody	= LANG_DT( "OFFLINEPMT_CARDTYPE", "Card Type" ) & ": " & VBCrlf
					Select Case sCardType
						Case "VI"
							sEmailBody	= sEmailBody & LANG_DT( "OFFLINEPAYMENT_VISA", "Visa" ) & VBCrlf
						Case "MA"
							sEmailBody	= sEmailBody & LANG_DT( "OFFLINEPAYMENT_MC", "MasterCard" ) & VBCrlf
						Case "AM"
							sEmailBody	= sEmailBody & LANG_DT( "OFFLINEPAYMENT_AM", "American Express" ) & VBCrlf
						Case "DIN"
							sEmailBody	= sEmailBody & LANG_DT( "OFFLINEPAYMENT_DIN", "Diners Club" ) & VBCrlf
						Case "DIS"
							sEmailBody	= sEmailBody & LANG_DT( "OFFLINEPAYMENT_DIS", "Discover" ) & VBCrlf
						Case "JC"
							sEmailBody	= sEmailBody & LANG_DT( "OFFLINEPAYMENT_JCB", "JCB" ) & VBCrlf
					End Select
					sEmailBody	= sEmailBody & LANG_DT( "OFFLINEPMT_CARDNUM", "Card Number" ) & ": ************ " & Right(sCardNumber, 4) & VBcrlf
					sEmailBody	= sEmailBody & VBcrlf
					sEmailBody	= sEmailBody & LANG_DT( "OFFLINEPMT_EXP", "Expiration" ) & ": " & sExpiration & VBcrlf
					sEmailBody	= sEmailBody & VBcrlf
					sEmailBody	= sEmailBody & LANG_DT( "OFFLINEPMT_POWEREDBY", "Powered by OneWorldStoreFront" ) & VBcrlf
					sEmailBody	= sEmailBody & "http://www.OneWorldStoreFront.com"
					
					sSubject	= Replace(Replace(LANG_DT( "OFFLINEPMT_CCINFO", "Order #1:2: credit card information." ), "1:", sOWOrderPrefix), "2:", sLongIDOrder)
					call sendmail (sOWCompany, sOWEmailSender, sOWEmailAdmin, sSubject, sEmailBody)
					
					call DB_CloseConnection()
					
					' go to confirmation page
					response.redirect "../CustomerAdmin/owSavedOrderDetails.asp?idOrder=" & sIDOrder & "&sAction=New"
				End If
			End If
		End If
		
	End Sub
	'************************************************************************************

Function ValidateCreditCard(ByRef pStrNumber, ByRef pStrType)

' THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT
' WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED,
' INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES
' OF MERCHANTABILITY AND/OR FITNESS FOR A  PARTICULAR
' PURPOSE.

' Copyright 2000 - 2001. All rights reserved.
' Lewis Moten
' http://www.lewismoten.com
' email: lewis@moten.com

	
	ValidateCreditCard = False ' Initialize negative results
	
	' Clean Credit Card Number (Removes dashes and spaces)
	pStrNumber = ParseDigits(pStrNumber)		
	
	' Validate number with LUHN Formula
	If Not LUHN(pStrNumber) Then Exit Function
	
	' Apply rules based on type of card
	Select Case pStrType
		Case "AM"
			Select Case Left(pStrNumber, 2)
				Case "34", "37"
					' Do Nothing
				Case Else
					Exit Function
			End Select
			If Not Len(pStrNumber) = 15 Then Exit Function
		Case "DIN"
			Select Case Left(pStrNumber, 2)
				Case "36" , "38"
					' Do Nothing
				Case "30"
					Select Case Left(pStrNumber, 3)
						Case "300", "301", "302", "303", "304", "305"
							' Do Nothing
						Case Else
							Exit Function
					End Select
				Case Else
					Exit Function
			End Select
			If Not Len(pStrNumber) = 14 Then Exit Function
		Case "DIS"
			If Not Left(pStrNumber, 4) = "6011" Then Exit Function
			If Not Len(pStrNumber) = 16 Then Exit Function
		Case "JC"
			If Left(pStrNumber, 1) = "3" And Len(pStrNumber) = 16 Then
				' Do Nothing
			ElseIf Left(pStrNumber, 14) = "2131" And Len(pStrNumber) = 15 Then
				' Do Nothing
			ElseIf Left(pStrNumber, 14) = "1800" And Len(pStrNumber) = 15 Then
				' Do Nothing
			Else
				Exit Function
			End If
		Case "MA"
			Select Case Left(pStrNumber, 2)
				Case "51", "52", "53", "54", "55"
					' Do Nothing
				Case Else
					Exit Function
			End Select
			If Not Len(pStrNumber) = 16 Then Exit Function
		Case "VI"
			If Not Left(pStrNumber, 1) = "4" Then Exit Function
			If Not (Len(pStrNumber) = 13 Or Len(pStrNumber) = 16) Then Exit Function
		Case Else
			' Unknown Card Type
			Exit Function
	End Select
	
	' We got this far so the number passed all the rules!
	ValidateCreditCard = True
	
End Function
' ------------------------------------------------------------------------------
Function LUHN(ByRef pStrDigits)
	
	Dim lLngMaxPosition
	Dim lLngPosition
	Dim lLngSum				' Sum of all positions
	Dim lLngDigit			' Current digit in specified position
	
	' Initialize
	lLngMaxPosition = Len(pStrDigits)
	lLngSum = 0
	
	' Read from right to left
	For lLngPosition = lLngMaxPosition To 1 Step -1
		
		' If we are working with an even digit (from the right)
		If (lLngMaxPosition - lLngPosition) Mod 2 = 0 Then
		
			lLngSum = lLngSum + CInt(Mid(pStrDigits, lLngPosition, 1))
		
		Else
		
			' Double the digit
			lLngDigit = CInt(Mid(pStrDigits, lLngPosition, 1)) * 2
			
			' shortcut adding sum of digits
			If lLngDigit > 9 Then lLngDigit = lLngDigit - 9
			
			lLngSum = lLngSum + lLngDigit
			
		End If
	Next

	' A mod 10 check must not return any remainders
	LUHN = lLngSum Mod 10 = 0

End Function
' ------------------------------------------------------------------------------
Function ParseDigits(ByRef pStrData)
	
	' Strip all the numbers from a string
	' (cleans up dashes and spaces)
	
	Dim lLngMaxPosition
	Dim lLngPosition
	
	lLngMaxPosition = Len(pStrData)
	
	For lLngPosition = 1 To lLngMaxPosition
		If IsNumeric(Mid(pStrData, lLngPosition, 1)) Then
			ParseDigits = ParseDigits & Mid(pStrData, lLngPosition, 1)
		End If
	Next

End Function
    	
%>
