<!--#include file="owFunctions/I_GeneralFunctions.asp"-->
<!--#include file="./owTemplates/Template.asp"-->
<%
	'************************************************************************************
	'*																					*
	'*	MODIFICATION TO THIS SCRIPT OR ANY FILES INCLUDED WITH 							*
	'*		ONEWORLDSTOREFRONT IS DONE AT YOUR OWN RISK!								*
	'*	Product  : OneWorldStoreFront													*

	'*	Copyright:	Copyright (C) 2004 OneWorldStoreFront.Com							*
	'*				Registration Number: 1024507										*
	'*				http://strategis.ic.gc.ca/											*
	'*																					*
	'************************************************************************************
	
	Dim iBeginPagination, bResetTtlNumItems, iTtlNumItems, iDBLoc, sSort, sSortQuerystring
	
	'************************************************************************************
	'*																					*
	'*																					*
	'*																					*
	'************************************************************************************
	Sub ActionSubroutine()

		Dim sSQLCount

		sIdCategory			= CONVERSION_Numeric(request("idCategory"), C_INTEGER)
		bSub				= CONVERSION_SQLEncode2(Request("bSub"), 1)
		sSupplierAccountUnq	= CONVERSION_Numeric(Trim(Request("sAccountUnq")), C_INTEGER)
		bSpecials			= CONVERSION_SQLEncode2(Trim(Request("bSpecials")), 1)
		sSort				= CONVERSION_SQLEncode2(Trim(Request("sSort")), 3)
		sSortQuerystring	= "bSpecials=" & bSpecials & "&sAccountUnq=" & sSupplierAccountUnq & "&bSub=" & bSub & "&idCategory=" & sIdCategory	' this has to be different because the sSort value will change depending on what the customer chooses
		sQuerystring		= "sSort=" & sSort & "&bSpecials=" & bSpecials & "&sAccountUnq=" & sSupplierAccountUnq & "&bSub=" & bSub & "&idCategory=" & sIdCategory
		bCatActive			= True
		
		If ( bSpecials = "T" ) Then
			' they want to see the specials
			sSQLText		= "SELECT * FROM Products P WHERE P.hotDeal = -1 AND P.listhidden=0 AND P.active=-1"
			sSQLCount		= "SELECT Count(*) FROM Products P WHERE P.hotDeal = -1 AND P.active = -1 AND P.listhidden = 0"
		Else
			If ( sSupplierAccountUnq <> 0 ) Then
				' they want to see a suppliers products (a brand)
				sSupplierBrand	= ACCNT_ReturnADV("OW_CUSTCOMPANY", "V", sSupplierAccountUnq, C_OVERRIDE_ADV)
				sSQLText		= "SELECT * FROM Products WHERE idsupplier = " & sSupplierAccountUnq & " AND listhidden=0 AND active = -1"
				sSQLCount		= "SELECT Count(*) FROM Products WHERE idsupplier = " & sSupplierAccountUnq & " AND active = -1 AND listhidden = 0"
			Else
				' make sure the category is active
				sSQLText = "SELECT * FROM Categories (NOLOCK) WHERE idCategory = " & sIdCategory & " AND Active = -1"
				Call DB_getFromDatabase(sSQLText, rsStoreData,"")
				If ( NOT rsStoreData.EOF ) Then
					If ( bSub = "T" ) Then
						' this is a sub category, so list just it's products
						sSQLText	= "SELECT * FROM CatProdMap CPM, Categories C, Products P WHERE P.idProduct = CPM.idProduct AND CPM.idCategory = C.idCategory AND C.idCategory=" & sIdCategory & " AND P.active = -1 AND P.listhidden = 0"
						sSQLCount	= "SELECT Count(*) FROM CatProdMap CPM, Categories C, Products P WHERE P.idProduct = CPM.idProduct AND CPM.idCategory = C.idCategory AND C.idCategory=" & sIdCategory & " AND P.active = -1 AND P.listhidden = 0"
					Else
						' this is a parent category, so list all it's sub categories products (unfortunately this has a side-effect of not ever listing any products within the parent category)
						sSQLText	= "SELECT * FROM CatProdMap CPM, Categories C, Products P WHERE P.idProduct = CPM.idProduct AND CPM.idCategory = C.idCategory AND C.idCategory=" & sIdCategory & " AND P.active = -1 AND P.listhidden = 0"
						sSQLCount	= "SELECT Count(*) FROM CatProdMap CPM, Categories C, Products P WHERE P.idProduct = CPM.idProduct AND CPM.idCategory = C.idCategory AND C.idCategory=" & sIdCategory & " AND P.active = -1 AND P.listhidden = 0"
					End If
					sCategoryDesc = rsStoreData("CategoryDesc")
				Else
					sSQLText		= "SELECT * FROM Categories WHERE idCategory = -1"
					sSQLCount		= "SELECT Count(*) FROM Categories WHERE idCategory = -1"
					bCatActive		= False
				End If
				Call DB_closeRecordset(rsStoreData)
			End If
		End If
		
		If ( bOWEnableCategorySort ) Then
			Select Case sSort
				Case "POP"		' Popularity
					sSQLText = sSQLText & " ORDER BY P.Visits DESC"
				Case "TOP"		' Top Sales
					sSQLText = sSQLText & " ORDER BY P.Sales DESC"
				Case "PLH"		' Price (Low to High)
					sSQLText = sSQLText & " ORDER BY P.Price ASC"
				Case "PHL"		' Price (High to Low)
					sSQLText = sSQLText & " ORDER BY P.Price DESC"
				Case "PAZ"		' Product Name (A to Z)
					sSQLText = sSQLText & " ORDER BY P.Description ASC"
				Case "PZA"		' Product Name (Z to A)
					sSQLText = sSQLText & " ORDER BY P.Description DESC"
				Case "BAZ"		' Brand
					sSQLText = sSQLText & " ORDER BY P.idSupplier ASC"
				Case Else
					If ( sSupplierAccountUnq = 0 ) And ( bSpecials <> "T" ) Then
						' neither the supplier nor the hot deals queries have the categories table in them, so this'd break it
						sSQLText = sSQLText & " ORDER BY C.categoryDesc"
					Else
						sSQLText = sSQLText & " ORDER BY P.Visits DESC"
					End If
			End Select
		End If

		If ( bCatActive ) Then
			iBeginPagination = SetupPagination( sSQLCount, bResetTtlNumItems, bResetDBLoc )
			Call PaginationQuery( sSQLText, rsStoreData, iBeginPagination )

			%>
			<script language='JavaScript1.2' type='text/javascript'>
			
				function PaginationLink(sQueryString){
					location = "owListProduct.asp?" + sQueryString;
				}
				
			</script>
			<table width=<%=sOWStoreTableWidth%> cellspacing=0 cellpadding=5>
				<tr bgcolor="#eeeeee">
					<td style='border-bottom: 1px solid #999999;'>
						<b>
						<%
						If ( sSupplierAccountUnq <> 0 ) Then
							Response.Write "<B>" & sSupplierBrand & "</b>"
						ElseIf ( bSpecials = "T" ) Then
							Response.Write "<B>" & LANG_DT( "LISTPROD_HOTDEALS", "Hot Deals!" ) & "</b>"
						Else
							Call STRUCTURE_Breadcrumbs(sBreadCrumb, sIdCategory)
							Response.Write sBreadCrumb
						End If
						%>
						</b>
					</td>
				</tr>
				<tr>
					<td>
						<%
						Call DisplayCategoryHead(sIdCategory)
						
						' display subcategories here - 3 across
						If ( bSpecials <> "T" ) And ( sSupplierAccountUnq = 0 ) Then
							sSQLText = "SELECT * FROM Categories (NOLOCK) WHERE idParentCategory = " & sIdCategory & " AND Active = -1  ORDER BY categoryDesc"
							Call DB_getFromDatabase(sSQLText, rsStoreData2, "")
							If ( NOT rsStoreData2.EOF ) Then
								%>
								<table width=100% border="0" cellpadding="0" cellspacing="0">
									<tr>
										<td>
							            	<table border="0" cellpadding="5" cellspacing="0" class='BodyBoxHead1'>
							            		<tr>
							            			<td align=right class='BodyBoxHead2' nowrap><b><%=LANG_DT( "LISTPROD_MORECHOICE", "More choices" )%>: <%=sCategoryDesc%></b></td>
							            			<td width=100% class='BodyBoxHead3'>&nbsp;</td>
							             		</tr>
							            	</table>
							            </td>
									</tr>
									<tr>
										<td>
							            	
            <table width=100% border="0" cellpadding="5" cellspacing="0" class='BodyBox'>
              <tr> 
                <%
													While ( NOT rsStoreData2.EOF )
														%>
                <td width="1"> <a href="<%=sOWStoreUrlNonSSL%>owListProduct.asp?bSub=T&idCategory=<%=(rsStoreData2("idCategory"))%>" class='LeftNavLinks'><img src='<%=sPath%>owTemplates/images/NavArrow.gif' border=0 align=middle></a> 
                </td>
                <td><a href="<%=sOWStoreUrlNonSSL%>owListProduct.asp?bSub=T&idCategory=<%=(rsStoreData2("idCategory"))%>" class='LeftNavLinks'><%=(rsStoreData2("categoryDesc"))%></a></td>
                <%
														iCurOGNum = iCurOGNum + 1
														If ( iCurOGNum = 4 ) Then
															iCurOGNum = 0
															Response.Write "</tr><tr>"
														End If
				
														rsStoreData2.MoveNext
													Wend
													%>
              </tr>
            </table>
							            </td>
									</tr>
								</table>
				            	<br>
				            	<%
							End If
							Call DB_closeRecordset(rsStoreData2)
						End If
						
						
						' display products within this category that are featured
						
						
						If ( bOWEnableCategorySort ) Then
							Call DisplaySortDropDown(sSort)
						End If
						Call TEMPLATE_PrintRecordsetNav( sURL, iOWNumPerPage, iTtlNumItems, iDBLoc, sQuerystring )
						If ( rsStoreData.EOF ) Then
							If ( sSupplierAccountUnq <> 0 ) Then
								Response.Write "<B>" & Replace(LANG_DT( "LISTPROD_NOPRODSFORSUPPLIER", "No products for 1: were found." ), "1:", sSupplierBrand) & "</b><BR><BR>"
							ElseIf ( bSpecials = "T" ) Then
								Response.Write "<B>" & LANG_DT( "LISTPROD_NOHOTDEALS", "No Hot Deals! products were found." ) & "</b><BR><BR>"
							Else
								Response.Write "<B>" & LANG_DT( "LISTPROD_NOPRODSINCAT", "No products were found within this category." ) & "</b><BR><BR>"
							End If
						else
							sSQLCount = 0
							While ( ( NOT rsStoreData.EOF ) And ( sSQLCount < iOWNumPerPage ) )
								sIdProduct		= rsStoreData("idProduct")
								sDescription	= rsStoreData("description")   
								sPrice			= rsStoreData("price")   
								sBtoBPrice		= rsStoreData("bToBPrice")   
								slistprice		= rsStoreData("listprice")
								sSmallImageUrl	= rsStoreData("smallImageUrl")   
								sStock			= rsStoreData("stock")   
								sVisits			= rsStoreData("visits")
								sNumRanking		= rsStoreData("NumRanking")
								sRanking		= rsStoreData("Ranking")
								sIDSupplier		= rsStoreData("idSupplier")
								sSKU			= rsStoreData("SKU")
								sShortDesc		= rsStoreData("ShortDesc")
								Call TEMPLATE_ProductListingDisplay( sShortDesc, sSKU, sIDSupplier, sSmallImageUrl, sDescription, slistprice, sPrice, sBtoBPrice, sStock, sVisits, sIdProduct, idCategory, sNumRanking, sRanking )
								sSQLCount = sSQLCount + 1
								rsStoreData.moveNext
							Wend
						End If
						Call DB_closeRecordset(rsStoreData)
						%>
					</td>
				</tr>
			</table>
			
<%
			Call TEMPLATE_PrintRecordsetNav2( sURL, iOWNumPerPage, iTtlNumItems, iDBLoc, sQuerystring )
		Else
			Call owMessage(LANG_DT( "LISTPROD_CATINACTIVE", "This category is currently inactive." ), C_ERROR)
		End If
		
	End Sub
	'********************************************************************************

	
	'********************************************************************************
	'*																				*
	'*																				*
	'********************************************************************************
	Sub DisplaySortDropDown(sSort)

		%>
<%
		
	End Sub
	'********************************************************************************
	
	
	'********************************************************************************
	'*																				*
	'*																				*
	'********************************************************************************
	Sub DisplayCategoryHead(sIdCategory)
	
		If ( sIdCategory <> 0 ) Then
			sSQLText = "SELECT idCategory, categoryDesc, idParentCategory, imageCategory, shortHTML, longHTML FROM categories WHERE IdCategory=" &sIdCategory& " AND idCategory<>1 AND active=-1"
			Call DB_getFromDatabase(sSQLText, rsStoreData2,"")   
			If ( NOT rsStoreData2.EOF ) Then
				%>
<%if trim(rsStoreData2("shortHTML"))<>"" then%>
<br>
<%=rsStoreData2("shortHTML")%><br>
				<%End If%>
				<%if trim(rsStoreData2("imageCategory"))<>"" then%>
				<img src="<%=sOWCategoryImage%>/<%=Server.HTMLEncode(rsStoreData2("imageCategory"))%>"><br>
				<%End If%>
				<%if trim(rsStoreData2("longHTML"))<>"" then%>
				<%=rsStoreData2("longHTML")%><br>
				<%End If%>
				<br>
				<%
			End If
			Call DB_closeRecordset(rsStoreData2)
		End If
		
	End Sub
	'********************************************************************************
%>